	cpu LMM
	.module digitalio.c
	.area text(rom, con, rel)
	.dbfile ./digitalio.c
	.dbfunc e DigitalIO_Start _DigitalIO_Start fV
_DigitalIO_Start::
	.dbline -1
	.dbline 46
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:   DigitalIO.c
; //  Version: 1.0, 2006/10/25 
; //  Generated by Andy Kiser
; //
; //  DESCRIPTION:  Processing digital inputs/outputs controlled by USB
; //
; //-----------------------------------------------------------------------------
; // Originally authored by Toradex AG. This work is now available under the terms and conditions
; // of the Creative Commons License 'Attribution CC BY', details of which can be found here:
; // http://creativecommons.org/licenses/by/3.0/
; //*****************************************************************************
; //*****************************************************************************
; #include <m8c.h>        // part specific constants and macros
; #include "feature.h"
; #include "parameters.h"
; #include "types_n_macros.h"
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; 
; // define registers according to the port definitions above
; #define PRT_IN_DM2	PRT5DM2
; #define PRT_IN_DM1	PRT5DM1
; #define PRT_IN_DM0	PRT5DM0
; #define PRT_IN_DR	PRT5DR
; 
; #define PRT_OUT_DM2	PRT4DM2
; #define PRT_OUT_DM1	PRT4DM1
; #define PRT_OUT_DM0	PRT4DM0
; #define PRT_OUT_DR	PRT4DR
; 
; #define PRT_LED_DM2	PRT0DM2
; #define PRT_LED_DM1	PRT0DM1
; #define PRT_LED_DM0	PRT0DM0
; #define PRT_LED_DR	PRT0DR
; 
; #define MASK_LED	0x02	// %0000'0010  -> LED connected to PORT0[1]
; 
; // state variables
; static BYTE DigOut_Shadow;
; 
; //-----------------------------------------------------------------------------
; // Initialize Digital Input / Output pins
; //-----------------------------------------------------------------------------
; void DigitalIO_Start()
; {
	.dbline 48
; 	// -- initialize "ShowUp" LED
; 	GPIO_DM_OPENDRAIN(LED_SHOWUP)
	or REG[0x3],2
	.dbline 48
	or F,0x10  ; iopage = 1
	or REG[0x1],2
	and F,0xEF ; iopage = 0
	.dbline 48
	or F,0x10  ; iopage = 1
	or REG[ 0],2
	and F,0xEF ; iopage = 0
	.dbline 49
; 	GPIO_HIGH(LED_SHOWUP)
	or REG[ 0],2
	.dbline 53
; 	
; 	// -- initialize Digital Outputs
; 	// Set Port4 Drivemode to [001b] (Strong Digital Output)
; 	PRT_OUT_DM2 = 0x00;	// set driver mode and strength
	mov REG[0x13],0
	.dbline 54
; 	PRT_OUT_DM1 = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[0x11],0
	and F,0xEF ; iopage = 0
	.dbline 55
; 	PRT_OUT_DM0 = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x10],-1
	and F,0xEF ; iopage = 0
	.dbline 57
; 	
; 	DigOut_Shadow = 0x00;
	mov REG[0xd0],>_DigOut_Shadow
	mov [_DigOut_Shadow],0
	.dbline 58
; 	PRT_OUT_DR  = DigOut_Shadow;	// set all 8 outputs to 0
	mov A,[_DigOut_Shadow]
	mov REG[0x10],A
	.dbline -2
	.dbline 65
; 
; 	// -- initialize Digital Inputs
; 	// Set Port5 Drivemode to [010b] (Digital Input)
; 	//PRT_IN_DM2 = 0x00;	// set driver mode and strength
; 	//PRT_IN_DM1 = 0xFF;
; 	//PRT_IN_DM0 = 0x00;
; }
L7:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DigitalIO_Suspend _DigitalIO_Suspend fV
_DigitalIO_Suspend::
	.dbline -1
	.dbline 71
; 
; //-----------------------------------------------------------------------------
; // Prepare for Suspend
; //-----------------------------------------------------------------------------
; void DigitalIO_Suspend()
; {
	.dbline 74
; 	// -- Set all Drivemodes to [110b] (HiZ, digital in disabled for zero power)
; 	// particular use (e.g. "smile" LED)
; 	GPIO_DM_HIGHZ(LED_SHOWUP)
	and REG[0x3],-3
	.dbline 74
	or F,0x10  ; iopage = 1
	or REG[0x1],2
	and F,0xEF ; iopage = 0
	.dbline 74
	or F,0x10  ; iopage = 1
	and REG[ 0],-3
	and F,0xEF ; iopage = 0
	.dbline 77
; 	
; 	// initialize Digital Outputs
; 	PRT_OUT_DM2 = 0xFF;	// set driver mode and strength
	mov REG[0x13],-1
	.dbline 78
; 	PRT_OUT_DM1 = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x11],-1
	and F,0xEF ; iopage = 0
	.dbline 79
; 	PRT_OUT_DM0 = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[0x10],0
	and F,0xEF ; iopage = 0
	.dbline -2
	.dbline 85
; 	
; 	// initialize Digital Inputs
; 	//PRT_IN_DM2 = 0xFF;	// set driver mode and strength
; 	//PRT_IN_DM1 = 0xFF;
; 	//PRT_IN_DM0 = 0x00;
; }
L8:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DigitalIO_Resume _DigitalIO_Resume fV
_DigitalIO_Resume::
	.dbline -1
	.dbline 91
; 
; //-----------------------------------------------------------------------------
; // Resume from Suspend 
; //-----------------------------------------------------------------------------
; void DigitalIO_Resume()
; {
	.dbline 95
; 	// -- restore drive modes
; 	
; 	// -- initialize "ShowUp" LED
; 	GPIO_DM_OPENDRAIN(LED_SHOWUP)
	or REG[0x3],2
	.dbline 95
	or F,0x10  ; iopage = 1
	or REG[0x1],2
	and F,0xEF ; iopage = 0
	.dbline 95
	or F,0x10  ; iopage = 1
	or REG[ 0],2
	and F,0xEF ; iopage = 0
	.dbline 96
; 	GPIO_HIGH(LED_SHOWUP)
	or REG[ 0],2
	.dbline 100
; 	
; 	// -- initialize Digital Outputs
; 	// Set Port4 Drivemode to [001b] (Strong Digital Output)
; 	PRT_OUT_DM2 = 0x00;	// set driver mode and strength
	mov REG[0x13],0
	.dbline 101
; 	PRT_OUT_DM1 = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[0x11],0
	and F,0xEF ; iopage = 0
	.dbline 102
; 	PRT_OUT_DM0 = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x10],-1
	and F,0xEF ; iopage = 0
	.dbline -2
	.dbline 109
; 
; 	// -- initialize Digital Inputs
; 	// Set Port2 Drivemode to [010b] (Digital Input)
; 	//PRT_IN_DM2 = 0x00;	// set driver mode and strength
; 	//PRT_IN_DM1 = 0xFF;
; 	//PRT_IN_DM0 = 0x00;
; }
L9:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile ./digitalio.c
L11:
	.word 0
	.area text(rom, con, rel)
	.dbfile ./digitalio.c
	.dbfunc e FSM_LEDmode _FSM_LEDmode fV
	.dbsym s Count_ms L11 i
;      LedStatus -> X+0
_FSM_LEDmode::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 116
; 
; //-----------------------------------------------------------------------------
; // ShowUp state machine
; // call this function once every millisecond
; //-----------------------------------------------------------------------------
; void FSM_LEDmode ()
; {
	.dbline 121
; 	static WORD Count_ms = 0;
; 	BYTE		LedStatus;
; 
; 	#define PAR8_LEDMODE 1
; 	Get_Param_8(PAR8_LEDMODE, VOLATILE, &LedStatus);
	mov REG[0xd0],>__r0
	mov A,3
	push A
	push X
	mov A,0
	push A
	mov A,1
	push A
	xcall _Get_Param_8
	add SP,-4
	.dbline 123
; 	
; 	switch (LedStatus)
	mov A,[X+0]
	mov [X+2],A
	mov [X+1],0
	cmp [X+1],0
	jnz X2
	cmp [X+2],0
	jz L15
X2:
	cmp [X+1],0
	jnz X3
	cmp [X+2],1
	jz L16
X3:
	cmp [X+1],0
	jnz X4
	cmp [X+2],2
	jz L17
X4:
	cmp [X+1],0
	jnz X5
	cmp [X+2],3
	jz L22
X5:
	cmp [X+1],0
	jnz X6
	cmp [X+2],4
	jz L42
X6:
	cmp [X+1],0
	jnz X7
	cmp [X+2],5
	jz L27
X7:
	cmp [X+1],0
	jnz X8
	cmp [X+2],6
	jz L30
X8:
	cmp [X+1],0
	jnz X9
	cmp [X+2],7
	jz L33
X9:
	cmp [X+1],0
	jnz X10
	cmp [X+2],8
	jz L36
X10:
	cmp [X+1],0
	jnz X11
	cmp [X+2],9
	jz L39
X11:
	xjmp L12
X0:
	.dbline 124
; 	{
L15:
	.dbline 127
; 	// ---- LED OFF
; 	case 0:
; 		GPIO_HIGH(LED_SHOWUP) // LED off
	or REG[ 0],2
	.dbline 128
; 		break;
	xjmp L13
L16:
	.dbline 132
; 		
; 	// ---- LED ON
; 	case 1:
; 		GPIO_LOW(LED_SHOWUP) // LED on
	and REG[ 0],-3
	.dbline 133
; 		break;
	xjmp L13
L17:
	.dbline 137
; 		
; 	// ---- LED blink slow
; 	case 2:
; 		if (Count_ms == 0)
	mov REG[0xd0],>L11
	cmp [L11],0
	jnz L18
	cmp [L11+1],0
	jnz L18
X12:
	.dbline 138
; 		{
	.dbline 139
; 			GPIO_LOW(LED_SHOWUP) // LED on
	and REG[ 0],-3
	.dbline 140
; 			Count_ms = 500;
	mov REG[0xd0],>L11
	mov [L11+1],-12
	mov [L11],1
	.dbline 141
; 		}
	xjmp L13
L18:
	.dbline 142
; 		else if (Count_ms == 450)
	mov REG[0xd0],>L11
	cmp [L11],1
	jnz L13
	cmp [L11+1],-62
	jnz L13
X13:
	.dbline 143
; 			GPIO_HIGH(LED_SHOWUP) // LED off
	or REG[ 0],2
	.dbline 144
; 		break;
	xjmp L13
L22:
	.dbline 148
; 	// ---- LED blink fast
; 
; 	case 3:
; 		if (Count_ms == 0)
	mov REG[0xd0],>L11
	cmp [L11],0
	jnz L23
	cmp [L11+1],0
	jnz L23
X14:
	.dbline 149
; 		{
	.dbline 150
; 			GPIO_LOW(LED_SHOWUP) // LED on
	and REG[ 0],-3
	.dbline 151
; 			Count_ms = 150;
	mov REG[0xd0],>L11
	mov [L11+1],-106
	mov [L11],0
	.dbline 152
; 		}
	xjmp L13
L23:
	.dbline 153
; 		else if (Count_ms == 100)
	mov REG[0xd0],>L11
	cmp [L11],0
	jnz L13
	cmp [L11+1],100
	jnz L13
X15:
	.dbline 154
; 			GPIO_HIGH(LED_SHOWUP) // LED off
	or REG[ 0],2
	.dbline 155
; 		else;
	.dbline 156
; 		break;
	xjmp L13
L27:
	.dbline 159
; 	// ---- LED on if switch 0 active
; 	case 5:
; 		if (CSD_1_baSnsOnMask[0]&0x01)
	mov REG[0xd0],>_CSD_1_baSnsOnMask
	tst [_CSD_1_baSnsOnMask],1
	jz L28
	.dbline 160
; 			GPIO_LOW(LED_SHOWUP) // LED on
	and REG[ 0],-3
	xjmp L13
L28:
	.dbline 162
; 		else 
; 			GPIO_HIGH(LED_SHOWUP) // LED off
	or REG[ 0],2
	.dbline 163
; 		break;
	xjmp L13
L30:
	.dbline 166
; 	// ---- LED on if switch 1 active
; 	case 6:
; 		if (CSD_1_baSnsOnMask[0]&0x02)
	mov REG[0xd0],>_CSD_1_baSnsOnMask
	tst [_CSD_1_baSnsOnMask],2
	jz L31
	.dbline 167
; 			GPIO_LOW(LED_SHOWUP) // LED on
	and REG[ 0],-3
	xjmp L13
L31:
	.dbline 169
; 		else 
; 			GPIO_HIGH(LED_SHOWUP) // LED off
	or REG[ 0],2
	.dbline 170
; 		break;
	xjmp L13
L33:
	.dbline 173
; 	// ---- LED on if switch 2 active
; 	case 7:
; 		if (CSD_1_baSnsOnMask[0]&0x04)
	mov REG[0xd0],>_CSD_1_baSnsOnMask
	tst [_CSD_1_baSnsOnMask],4
	jz L34
	.dbline 174
; 			GPIO_LOW(LED_SHOWUP) // LED on
	and REG[ 0],-3
	xjmp L13
L34:
	.dbline 176
; 		else 
; 			GPIO_HIGH(LED_SHOWUP) // LED off
	or REG[ 0],2
	.dbline 177
; 		break;
	xjmp L13
L36:
	.dbline 180
; 	// ---- LED on if switch 3 active
; 	case 8:
; 		if (CSD_1_baSnsOnMask[0]&0x08)
	mov REG[0xd0],>_CSD_1_baSnsOnMask
	tst [_CSD_1_baSnsOnMask],8
	jz L37
	.dbline 181
; 			GPIO_LOW(LED_SHOWUP) // LED on
	and REG[ 0],-3
	xjmp L13
L37:
	.dbline 183
; 		else 
; 			GPIO_HIGH(LED_SHOWUP) // LED off
	or REG[ 0],2
	.dbline 184
; 		break;
	xjmp L13
L39:
	.dbline 187
; 	// ---- LED on if any switch active
; 	case 9:
; 		if (CSD_1_baSnsOnMask[0])
	mov REG[0xd0],>_CSD_1_baSnsOnMask
	cmp [_CSD_1_baSnsOnMask],0
	jz L40
	.dbline 188
; 			GPIO_LOW(LED_SHOWUP) // LED on
	and REG[ 0],-3
	xjmp L13
L40:
	.dbline 190
; 		else 
; 			GPIO_HIGH(LED_SHOWUP) // LED off
	or REG[ 0],2
	.dbline 191
; 		break;
	xjmp L13
L42:
	.dbline 194
; 	// ---- LED blink quad
; 	case 4:
; 		switch (Count_ms)
	mov REG[0xd0],>L11
	mov A,[L11+1]
	sub A,64
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov REG[0xd0],>L11
	mov A,[L11]
	xor A,-128
	sbb A,(6 ^ 0x80)
	mov REG[0xd0],>__r0
	or A,[__rY]
	jz L45
	jnc L49
X16:
L48:
	mov REG[0xd0],>L11
	mov A,[L11+1]
	sub A,70
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov REG[0xd0],>L11
	mov A,[L11]
	xor A,-128
	sbb A,(5 ^ 0x80)
	mov REG[0xd0],>__r0
	or A,[__rY]
	jz L46
	jnc L51
X17:
L50:
	mov REG[0xd0],>L11
	cmp [L11],0
	jnz X18
	cmp [L11+1],0
	jz L47
X18:
	xjmp L43
L51:
	mov REG[0xd0],>L11
	mov A,[L11+1]
	sub A,120
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov REG[0xd0],>L11
	mov A,[L11]
	xor A,-128
	sbb A,(5 ^ 0x80)
	jc L43
	mov REG[0xd0],>__r0
	or A,[__rY]
	jz L45
X19:
L52:
	mov REG[0xd0],>L11
	cmp [L11],6
	jnz X20
	cmp [L11+1],14
	jz L46
X20:
	xjmp L43
L49:
	mov REG[0xd0],>L11
	mov A,[L11+1]
	sub A,8
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov REG[0xd0],>L11
	mov A,[L11]
	xor A,-128
	sbb A,(7 ^ 0x80)
	mov REG[0xd0],>__r0
	or A,[__rY]
	jz L45
	jnc L54
X21:
L53:
	mov REG[0xd0],>L11
	cmp [L11],6
	jnz X22
	cmp [L11+1],-42
	jz L46
X22:
	xjmp L43
L54:
	mov REG[0xd0],>L11
	mov A,[L11+1]
	sub A,-98
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov REG[0xd0],>L11
	mov A,[L11]
	xor A,-128
	sbb A,(7 ^ 0x80)
	jc L43
	mov REG[0xd0],>__r0
	or A,[__rY]
	jz L46
X23:
L55:
	mov REG[0xd0],>L11
	cmp [L11],7
	jnz X24
	cmp [L11+1],-48
	jz L45
X24:
	xjmp L43
X1:
	.dbline 195
; 		{
L45:
	.dbline 200
; 		case 2000:
; 		case 1800:
; 		case 1600:
; 		case 1400:
; 				GPIO_LOW(LED_SHOWUP) // LED on
	and REG[ 0],-3
	.dbline 201
; 				break;
	xjmp L44
L46:
	.dbline 207
; 
; 		case 1950:
; 		case 1750:
; 		case 1550:
; 		case 1350:
; 				GPIO_HIGH(LED_SHOWUP) // LED off
	or REG[ 0],2
	.dbline 208
; 				break;
	xjmp L44
L47:
	.dbline 211
; 				
; 		case 0:
; 				Count_ms = 2001;
	mov REG[0xd0],>L11
	mov [L11+1],-47
	mov [L11],7
	.dbline 213
; 		
; 		}
L43:
L44:
	.dbline 214
; 	}
L12:
L13:
	.dbline 215
	mov REG[0xd0],>L11
	cmp [L11],0
	jnz X25
	cmp [L11+1],0
	jz L56
X25:
	.dbline 216
	mov REG[0xd0],>L11
	dec [L11+1]
	sbb [L11],0
L56:
	.dbline -2
	.dbline 217
; 	if (Count_ms != 0)
; 		Count_ms--;
; }
L10:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l LedStatus 0 c
	.dbend
	.dbfunc e DigitalOut_Set _DigitalOut_Set fV
;        msk_xor -> X-6
;         msk_or -> X-5
;        msk_and -> X-4
_DigitalOut_Set::
	.dbline -1
	push X
	mov X,SP
	.dbline 223
; 
; //-----------------------------------------------------------------------------
; // Function to set the value of the 8 digital outputs
; //-----------------------------------------------------------------------------
; void DigitalOut_Set (BYTE msk_and, BYTE msk_or, BYTE msk_xor)
; {
	.dbline 224
; 	DigOut_Shadow = ( (DigOut_Shadow & msk_and) | msk_or ) ^ msk_xor;
	mov REG[0xd0],>_DigOut_Shadow
	mov A,[_DigOut_Shadow]
	and A,[X-4]
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov A,[X-5]
	or [__r0],A
	mov A,[X-6]
	xor [__r0],A
	mov A,[__r0]
	mov REG[0xd0],>_DigOut_Shadow
	mov [_DigOut_Shadow],A
	.dbline 225
; 	PRT_OUT_DR = DigOut_Shadow;
	mov A,[_DigOut_Shadow]
	mov REG[0x10],A
	.dbline -2
	.dbline 226
; }
L58:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l msk_xor -6 c
	.dbsym l msk_or -5 c
	.dbsym l msk_and -4 c
	.dbend
	.dbfunc e DigitalIn_Get _DigitalIn_Get fc
_DigitalIn_Get::
	.dbline -1
	.dbline 233
; 
; 
; //-----------------------------------------------------------------------------
; // Function returns value of the 8 digital inputs
; //-----------------------------------------------------------------------------
; BYTE DigitalIn_Get (void)
; {
	.dbline 234
; 	return PRT_IN_DR;
	mov A,REG[0x14]
	mov REG[0xd0],>__r0
	.dbline -2
L59:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile ./digitalio.c
_DigOut_Shadow:
	.byte 0
	.dbsym s DigOut_Shadow _DigOut_Shadow c
